.386
.model flat,stdcall
include Win32.inc
include Menu.imp
includelib \tasm\lib\import32.lib

.data
ClassName db "SimpleWinClass",0
AppName  db "Our First Window",0
MenuName db "FirstMenu",0
Test_string db "You selected Test menu item",0
Hello_string db "Hello, my friend",0
Goodbye_string db "See you again, bye",0

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
msg MSGSTRUCT ?
wc WNDCLASSEX ?
.const
IDM_TEST	equ 1
IDM_HELLO	equ 2
IDM_GOODBYE	equ 3
IDM_EXIT        equ 4

.code
start:
        CALL GetModuleHandle, NULL
	mov    hInstance,eax
        CALL GetCommandLine
        mov    CommandLine,eax
        CALL WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
        CALL ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
        LOCAL hwnd:HWND
        mov wc.cbSizeEx,48  ;12 members of the class X 4         
        mov wc.clsStyleEx,CS_HREDRAW or CS_VREDRAW
        mov wc.clsLpfnWndProcEx,OFFSET WndProc 
        mov wc.clsCbClsExtraEx,NULL  
        mov wc.clsCbWndExtraEx,NULL 
        push hInst
        pop wc.clsHInstanceEx
        mov wc.clsHbrBackgroundEx,COLOR_WINDOW+1
        mov wc.clsLpszMenuNameEx,OFFSET MenuName
        mov wc.clsLpszClassNameEx,OFFSET ClassName
        CALL LoadIcon,NULL,IDI_APPLICATION
        mov wc.clsHIconEx,eax       
        mov wc.hIconSmEx,eax
        CALL LoadCursor,NULL,IDC_ARROW
        mov wc.clsHCursorEx,eax

        CALL RegisterClassEx,OFFSET wc
        CALL CreateWindowEx,NULL,OFFSET ClassName,OFFSET AppName,\
           0cf0000h,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
        CALL ShowWindow, hwnd,SW_SHOWNORMAL
        CALL UpdateWindow, hwnd
	.WHILE TRUE
                CALL GetMessage, OFFSET msg,NULL,0,0
                .BREAK .IF (!eax)
                CALL DispatchMessage, OFFSET msg
	.ENDW
        mov     eax,msg.msWPARAM
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_DESTROY
                CALL PostQuitMessage,NULL
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF ax==IDM_TEST
                        CALL MessageBox,NULL,OFFSET Test_string,OFFSET AppName,MB_OK
		.ELSEIF ax==IDM_HELLO
                        CALL MessageBox, NULL,OFFSET Hello_string, OFFSET AppName,MB_OK
		.ELSEIF ax==IDM_GOODBYE
                        CALL MessageBox,NULL,OFFSET Goodbye_string, OFFSET AppName, MB_OK
		.ELSE
                        CALL DestroyWindow,hWnd
		.ENDIF
	.ELSE
                CALL DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
end start
